
#include <stdio.h>
#include <stdint.h>

enum
DNA_PROTEINS
{
  DNA_PROTIEN_A = 1,
  DNA_PROTIEN_T = 2,
  DNA_PROTIEN_G = 4,
  DNA_PROTIEN_C = 8,
};

void
loop() 
{
  for (int i = 0 ; i < 8; i++) {
    printf("i: %d\n", i);
  }
}

int
main()
{
  loop();
}

void
nope() 
{
  signed char c; // 1 byte (8 bits)

  printf("sizeof(c) %d\n", sizeof(c));

  printf("c: %b || %d\n", c, c);
  printf("A: %b\n", DNA_PROTIEN_A);
  printf("T: %b\n", DNA_PROTIEN_T);
  printf("G: %b\n", DNA_PROTIEN_G);
  printf("C: %b\n", DNA_PROTIEN_C);

  c |= DNA_PROTIEN_A;
  printf("c: %b || %d\n", c, c);
  c |= DNA_PROTIEN_T;
  printf("c: %b || %d\n", c, c);
  c |= DNA_PROTIEN_G;
  printf("c: %b || %d\n", c, c);
  c |= DNA_PROTIEN_C;
  printf("c: %b || %d\n", c, c);
  c |= 16 ; // upper 4 bits
  printf("c: %b || %d\n", c, c);
  c |= 32; // upper 4 bits
  printf("c: %b || %d\n", c, c);
  c |= 64; // upper 4 bits
  printf("c: %b || %d\n", c, c);
  c |= 128; // too far
  printf("c: %b || %d\n", c, c);
  c |= 256; // too far
  printf("c: %b || %d\n", c, c);
  c |= 512; // too far
  printf("c: %b || %d\n", c, c);
}

